// Hauptprogramm
// RC5 Sender mit PIC12C508
// Sendet drei verschiedene Codes
//
// Copyright 2000 by Holger Klabunde
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

#include "rc5send.h" //Pindefinitionen
#include "protos.h"
#include "phasemod.c"

//Globale Flags und Rckgabevariablen

unsigned char tastbuf;  //Tastaturpuffer fr lesen im INT
unsigned char toggle;   //Togglebit
unsigned char togglemask; //Merkt sich die Togglbits der Tasten
unsigned char comcode;  //Kommandocode

//25ms Pause
void Delay25ms()
{
 unsigned char i;
 for(i=0; i<25; i++)
  {
   TMR0=0;
   while(TMR0<250); //1ms Totzeit
  }
}

void main()
{ 
 unsigned char buf;

 OSCCAL=W; //Als erstes den Kalibrierwert fr den int. RC-Oszi sichern

 CLRWDT;         //Laut Datenblatt vor ndern Prescaler fr TMR0

 OPTION=0b00000001; //Wake up on pin change, weak pullups, Timer0 int. Source
                       //Prescaler 1:4
                       
//Ein TimerClock = 1us * 4 = 4us
 
//Nur GP0,1,3 knnen WakeUp machen und haben Pullups. Damit kommen nur
//sie als Eingnge fr die Taster in Frage
//An GP2 kommt die Sende-LED

 TRIS=0b111011; 	//0=Ausgang, 1=Eingang

 GPIO=0b111011;  //Port einmal schreiben

 if(GPWUF==0) togglemask=0; //Beim ersten einschalten Togglebits lschen

 while(1) // Anfang Programm Endlosschleife
  {
   tastbuf=~GPIO; //Tasten lesen, lowaktiv !!
   tastbuf&=0x0B; //nur die Pins Gp0,1,3 gltig
   
//Tastatur auswerten
   switch(tastbuf)
    {
     case KEY7: comcode=7;     break;
     case KEY6: comcode=6;     break;
     case KEY5: comcode=5;     break;
     default:   comcode=0;     break; //Ungltiger Kommandocode
    }   

    
   //Zur Sicherheit nur bei gltigen Kommandos weitermachen
   if(comcode>4)
    {

     //Togglebit der Taste merken bzw. verndern
     buf=0x01<<comcode; //Togglebit auf richtige Position schieben
     if(togglemask&buf) //Gesetzt ?
      {
       togglemask&=~buf; //Dann lschen
       toggle=0;         //Neues Togglebit
      }
     else //War nicht gesetzt
      {
       togglemask|=buf; //Dann setzen
       toggle=1;        //Neues Togglebit
      }
      
     PhaseMod(); //Codes 5x phasenmoduliert senden
     Delay25ms(); //Totzeit
     PhaseMod(); 
     Delay25ms(); //Totzeit
     PhaseMod(); 
     Delay25ms(); //Totzeit
     PhaseMod(); 
     Delay25ms(); //Totzeit
     PhaseMod(); 
     Delay25ms(); //Totzeit

    }//if comcode
    
   tastbuf=GPIO; //Laut Datenblatt soll man das machen
   SLEEP;      //Wenn alles getan ist schlafen bis Taste gedrckt wird
                 //Bei WakeUp gibt es einen Reset !
                 
  } // Ende Programm Endlosschleife
}

